﻿/*
** Job Arranger for ZABBIX
** Copyright (C) 2012 FitechForce, Inc. All Rights Reserved.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Data;
using System.Collections;
using jp.co.ftf.jobcontroller.Common;
//*******************************************************************
//                                                                  *
//                                                                  *
//  Copyright (C) 2012 FitechForce, Inc. All Rights Reserved.       *
//                                                                  *
//  * @author DHC 劉 偉 2012/10/04 新規作成<BR>                      *
//                                                                  *
//                                                                  *
//*******************************************************************
namespace jp.co.ftf.jobcontroller.JobController.Form.ScheduleEdit
{
/// <summary>
/// Container.xaml の相互作用ロジック
/// </summary>
    public partial class Container : UserControl
    {
        #region コンストラクタ
        public Container()
        {
            // 初期化 
            InitializeComponent();
        }
        #endregion

        #region フィールド

        /// <summary>削除起動時刻</summary>
        public DataRow[] deleteCalendarArray;

        /// <summary>削除ジョブネット</summary>
        public DataRow[] deleteJobnetArray;

        // 一旦削除（区域選択用） 
        /// <summary>マウス追従フラグ</summary>
        //private bool trackingMouseMove = false;

        // 2012.11.1一旦削除（区域選択用） 
        /// <summary>選択範囲</summary>
        //Rectangle temproaryEllipse;

        #endregion

        #region プロパティ


        /// <summary>ウィンドウ</summary>
        ContentControl _parantWindow;
        public ContentControl ParantWindow
        {
            get
            {
                return _parantWindow;
            }
            set
            {
                _parantWindow = value;
            }
        }


        /// <summary> 選択コントローラリスト</summary>
        List<System.Windows.Controls.Control> _currentSelectedControlCollection;
        public List<Control> CurrentSelectedControlCollection
        {
            get
            {
                if (_currentSelectedControlCollection == null)
                    _currentSelectedControlCollection = new List<Control>();
                return _currentSelectedControlCollection;
            }
        }

        /// <summary>ジョブネットID</summary>
        private string _calendarId;
        public string ScheduleId
        {
            get
            {
                return _calendarId;
            }
            set
            {
                _calendarId = value;
            }
        }

        /// <summary>更新日</summary>
        private string _updDate;
        public string UpdDate
        {
            get
            {
                return _updDate;
            }
            set
            {
                _updDate = value;
            }
        }

        /// <summary>仮更新日</summary>
        private string _tmpUpdDate;
        public string TmpUpdDate
        {
            get
            {
                return _tmpUpdDate;
            }
            set
            {
                _tmpUpdDate = value;
            }
        }
        /// <summary>ドラッグのジョブネットID</summary>
        private string _dragScheduleId;
        public string DragScheduleId
        {
            get
            {
                return _dragScheduleId;
            }
            set
            {
                _dragScheduleId = value;
            }
        }

        /// <summary>シフトキー押下状態フラグ</summary>
        public bool ShiftKeyIsPress
        {
            get
            {
                return (Keyboard.Modifiers == ModifierKeys.Shift);
            }
        }

        #endregion

        #region データ格納場所

        /// <summary>スケジュール管理テーブル</summary>
        public DataTable ScheduleControlTable { get; set; }

        /// <summary>スケジュール起動時刻テーブル</summary>
        public DataTable ScheduleDetailTable { get; set; }

        /// <summary>スケジュールジョブネットテーブル</summary>
        public DataTable ScheduleJobnetTable { get; set; }

        #endregion

        #region イベント



        //*******************************************************************
        /// <summary>コンテナを右クリック</summary>
        /// <param name="sender">源</param>
        /// <param name="e">マウスイベント</param>
        //*******************************************************************
        private void UserControl_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.ContextMenu.Visibility = Visibility.Visible;
        }

        private void select_deleteCalendar(object sender, EventArgs e)
        {
            if (dgCalendarBootTime.SelectedItems.Count > 0)
            {
                deleteCalendarArray = new DataRow[dgCalendarBootTime.SelectedItems.Count];
                for (int i = 0; i < dgCalendarBootTime.SelectedItems.Count; i++)
                {
                    System.Data.DataRowView selected = (System.Data.DataRowView)dgCalendarBootTime.SelectedItems[i];
                    deleteCalendarArray[i] = selected.Row;

                }
            }
                    
        }

        private void select_deleteJobnet(object sender, EventArgs e)
        {
            if (dgJobnet.SelectedItems.Count > 0)
            {
                deleteJobnetArray = new DataRow[dgJobnet.SelectedItems.Count];
                for (int i = 0; i < dgJobnet.SelectedItems.Count; i++)
                {
                    System.Data.DataRowView selected = (System.Data.DataRowView)dgJobnet.SelectedItems[i];
                    deleteJobnetArray[i] = selected.Row;
                }
            }
        }

        private void addCalendar_Click(object sender, EventArgs e)
        {
            ScheduleCalendarRegistWindow scheduleCalendarRegistWindow = new ScheduleCalendarRegistWindow(this);
            scheduleCalendarRegistWindow.ShowDialog();
        }

        private void delCalendar_Click(object sender, EventArgs e)
        {
            if (deleteCalendarArray != null)
            {
                foreach (DataRow row in deleteCalendarArray)
                {
                    row.Delete();
                }
            }
        }

        private void addJobnet_Click(object sender, EventArgs e)
        {
            ScheduleJobnetRegistWindow scheduleJobnetRegistWindow = new ScheduleJobnetRegistWindow(this);
            scheduleJobnetRegistWindow.ShowDialog();

        }
        private void delJobnet_Click(object sender, EventArgs e)
        {
            if (deleteJobnetArray != null)
            {
                foreach (DataRow row in deleteJobnetArray)
                {
                    row.Delete();
                }
            }
        }

        #endregion

        #region publicメッソド

        //*******************************************************************
        /// <summary>選択モジュールを追加</summary>
        /// <param name="uc">部品</param>
        //*******************************************************************
        public void AddSelectedControl(System.Windows.Controls.Control uc)
        {
            if (!CurrentSelectedControlCollection.Contains(uc))
            {
                _currentSelectedControlCollection.Add(uc);
            }

        }

        public void SetDisable()
        {
            calendarAdd.IsEnabled = false;
            calendarDel.IsEnabled = false;
            jobnetAdd.IsEnabled = false;
            jobnetDel.IsEnabled = false;

            dgCalendarBootTime.CellStyle = Application.Current.Resources["DisableDataGridCell"] as Style;
            dgJobnet.CellStyle = Application.Current.Resources["DisableDataGridCell"] as Style;
            dgJobnet.IsReadOnly = true;
            dgCalendarBootTime.IsReadOnly = true;
            dgCalendarBootTime.SelectionChanged -= select_deleteCalendar;
            dgJobnet.SelectionChanged -= select_deleteJobnet;
        }



        #endregion

        #region privateメッソド




        #region DB処理



        #endregion

        #endregion
    }

}
